/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_SPF
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

/* This file is part of mailfromd.             -*- c -*-
   Copyright (C) 2007 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

#include "spf.h"

static size_t spf_explanation_loc
#line 21 "bi_spf.m4"
;
static size_t spf_mechanism_loc
#line 22 "bi_spf.m4"
;
static size_t spf_ttl_loc
#line 23 "bi_spf.m4"
;
static size_t spf_explanation_prefix_loc
#line 24 "bi_spf.m4"
;
       
static void
update_spf_vars(eval_environ_t env, spf_answer_t *ans)
{
	
#line 29
{ size_t off;
#line 29
  if (ans->exp_text)
#line 29
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(ans->exp_text) + 1)), ans->exp_text);
#line 29
  else
#line 29
     off = 0;
#line 29
  *env_data_ref(env, spf_explanation_loc) = (STKVAL) (off); }
#line 29
;
	
#line 30
{ size_t off;
#line 30
  if (ans->mech)
#line 30
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(ans->mech) + 1)), ans->mech);
#line 30
  else
#line 30
     off = 0;
#line 30
  *env_data_ref(env, spf_mechanism_loc) = (STKVAL) (off); }
#line 30
;
	*env_data_ref(env, spf_ttl_loc) = (STKVAL) (ans->ttl);
}

void
#line 34
bi_spf_check_host(eval_environ_t env)
#line 34

#line 34 "bi_spf.m4"
{
#line 34
	
#line 34

#line 34

#line 34
char * ip = (char *) get_string_arg(env, 0);
#line 34
        char * domain = (char *) get_string_arg(env, 1);
#line 34
        char * sender = (char *) get_string_arg(env, 2);
#line 34
        char * helo_domain = (char *) get_string_arg(env, 3);
#line 34
        char * my_domain = (char *) get_string_arg(env, 4);
#line 34
        
#line 34
        adjust_stack(env, 5);
#line 34

#line 34
	if (prog_trace_option & BUILTIN_MASK_spf)
#line 34
		prog_trace(env, "spf_check_host %s %s %s %s %s",ip, domain, sender, helo_domain, my_domain);;

{
	spf_result res;
	spf_query_t q;
	spf_answer_t ans;

	q.ipstr = ip;
	q.domain = domain;
	q.sender = sender;
	q.helo_domain = helo_domain;
	q.my_domain = my_domain;
	q.exp_prefix = *env_data_ref(env, spf_explanation_prefix_loc) ;
	res = spf_check_host(&q, &ans);
	update_spf_vars(env, &ans);
	spf_answer_free(&ans);
	
#line 50
do {
#line 50
  push(env, (STKVAL) (res));
#line 50
  return;
#line 50
} while (0);
}
}

void
#line 54
bi_spf_test_record(eval_environ_t env)
#line 54

#line 54 "bi_spf.m4"
{
#line 54
	
#line 54

#line 54

#line 54
char * record = (char *) get_string_arg(env, 0);
#line 54
        char * ip = (char *) get_string_arg(env, 1);
#line 54
        char * domain = (char *) get_string_arg(env, 2);
#line 54
        char * sender = (char *) get_string_arg(env, 3);
#line 54
        char * helo_domain = (char *) get_string_arg(env, 4);
#line 54
        char * my_domain = (char *) get_string_arg(env, 5);
#line 54
        
#line 54
        adjust_stack(env, 6);
#line 54

#line 54
	if (prog_trace_option & BUILTIN_MASK_spf)
#line 54
		prog_trace(env, "spf_test_record %s %s %s %s %s %s",record, ip, domain, sender, helo_domain, my_domain);;
#line 56

{
	spf_result res;
	spf_query_t q;
	spf_answer_t ans;

	q.ipstr = ip;
	q.domain = domain;
	q.sender = sender;
	q.helo_domain = helo_domain;
	q.my_domain = my_domain;
	q.exp_prefix = *env_data_ref(env, spf_explanation_prefix_loc) ;
	res = spf_test_record(record, &q, &ans);
	update_spf_vars(env, &ans);
	spf_answer_free(&ans);
	
#line 71
do {
#line 71
  push(env, (STKVAL) (res));
#line 71
  return;
#line 71
} while (0);
}
}


#line 75
void
#line 75
spf_init_builtin()
#line 75
{
#line 75
	#line 21 "bi_spf.m4"
	spf_explanation_loc = builtin_variable_install("spf_explanation", dtype_string, VAR_VOLATILE)->off;
#line 22 "bi_spf.m4"
	spf_mechanism_loc = builtin_variable_install("spf_mechanism", dtype_string, VAR_VOLATILE)->off;
#line 23 "bi_spf.m4"
	spf_ttl_loc = builtin_variable_install("spf_ttl", dtype_number, VAR_VOLATILE)->off;
#line 24 "bi_spf.m4"
	spf_explanation_prefix_loc = builtin_variable_install("spf_explanation_prefix", dtype_string, VAR_VOLATILE)->off;
#line 34 "bi_spf.m4"
va_builtin_install_ex("spf_check_host", bi_spf_check_host, 0, 0, dtype_number, 5, 0, 0, dtype_string, dtype_string, dtype_string, dtype_string, dtype_string);
#line 54 "bi_spf.m4"
va_builtin_install_ex("spf_test_record", bi_spf_test_record, 0, 0, dtype_number, 6, 0, 0, dtype_string, dtype_string, dtype_string, dtype_string, dtype_string, dtype_string);

#line 75 "bi_spf.m4"
		
#line 75
}
#line 549 "../src/snarf.m4"

#line 549

